#ifndef CHOICEWIDGET_H
#define CHOICEWIDGET_H

#include "gmc-common_global.h"

#include <QGroupBox>

class QItemSelection;

class TreeNode;

class ChoiceDialog;
class ChoiceTreeNodeProxyModel;
class ChoiceTreeNodeSortFilterProxyModel;

namespace Ui
{
class ChoiceWidget;
}

class GMC_COMMON_SHARED_EXPORT ChoiceWidget : public QGroupBox
{

    Q_OBJECT

signals:

    void treeNodeDoubleClicked( TreeNode * );

public:

    ChoiceWidget( QWidget * /*parent*/ = nullptr );
    virtual ~ChoiceWidget();

    ChoiceTreeNodeProxyModel *choiceModel() const;
    void setChoiceModel( ChoiceTreeNodeProxyModel * /*checkModel*/ );

    const QSet< int > &acceptColumns() const;
    void setAcceptColumns( const QSet<int> &acceptColumns );

    bool isChoiceEnabled() const;
    void setChoiceEnabled( bool /*choiceEnabled*/ );

protected slots:

    void selectionChanged( const QItemSelection & /*selected*/ );
    void unchoice();
    void doubleClicked( const QModelIndex & /*index*/ );

protected:

    Ui::ChoiceWidget *_ui;
    ChoiceDialog *_choiceDialog;

    bool _choiceEnabled;
    ChoiceTreeNodeProxyModel *_choiceModel;
    ChoiceTreeNodeSortFilterProxyModel *_choiceProxyModel;

};

#endif // CHOICEWIDGET_H
