#ifndef ELEMENTSWIDGETPROXYMODEL_H
#define ELEMENTSWIDGETPROXYMODEL_H

#include "gmc-common_global.h"

#include "treenodemodel.h"
#include "elementmodelextension.h"

class TreeNode;

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT ListWidgetProxyModel
: public FilterTreeNodeSortFilterProxyModel
, public ElementModelExtension
{

    Q_OBJECT

public:

    ListWidgetProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                        , QObject * /*parent*/  = nullptr );
    virtual ~ListWidgetProxyModel();

};


//******************************************************************************

class GMC_COMMON_SHARED_EXPORT NodesWidgetProxyModel
: public ListWidgetProxyModel
{

    Q_OBJECT

public:

    NodesWidgetProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                         , QObject * /*parent*/  = nullptr );
    virtual ~NodesWidgetProxyModel();

protected:

    bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const override;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT ElementsWidgetProxyModel
: public ListWidgetProxyModel
{

    Q_OBJECT

public:

    ElementsWidgetProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                            , QObject * /*parent*/  = nullptr );
    virtual ~ElementsWidgetProxyModel();

protected:

    bool filterAcceptsColumn( int /*srcColumn*/, const QModelIndex & /*srcParentIndex*/ ) const override;
    bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const override;

};

//******************************************************************************

#endif // ELEMENTSWIDGETPROXYMODEL_H
