#ifndef ELEMENTWIDGETCONTAINER2_H
#define ELEMENTWIDGETCONTAINER2_H

#include "gmc-common_global.h"

#include <QWidget>

#include "elementwidget.h"
#include <QItemSelection>

namespace Ui
{
class ElementWidgetContainer2;
}

class QItemSelection;

class GMC_COMMON_SHARED_EXPORT ElementWidgetContainer2 : public QWidget
{

    Q_OBJECT

signals :

    void elementContextOperationChanged( Element * /*element*/ );
    void elementWidgetChanged( ElementWidget * );

public:
    enum WidgetType { EmptyWidget
                    , MultiWidget
                    , SingleWidget
                    , _CountColumns };

    ElementWidgetContainer2( QWidget * /*parent*/ = nullptr );
    virtual ~ElementWidgetContainer2();

    ElementWidget *currentElementWidget() const;

    void enableTabChange( bool /*enable*/ );

public slots:

    void reset();
    void setCurrentElementWidget( const QItemSelection & /*selection*/
                                , ElementWidgetRole /*role*/ = ViewEditElementWidgetRole );
    void updateCaption();

protected slots:

    void currentTabChanged( int );

private:

    Ui::ElementWidgetContainer2 *_ui;
    ContextOperation *_captionContextOperation;

};

#endif
