#ifndef PGSQLCLUSTER_H
#define PGSQLCLUSTER_H

#include "gmc-common_global.h"

#include <QObject>
#include <QString>


class GMC_COMMON_SHARED_EXPORT PgsqlCluster : public QObject
{
    Q_OBJECT

public:
    static PgsqlCluster* fromString(const QString& string);
    const QStringList usernames() const;
    bool isWork() const;
    void start() const;
    void createUser(const QString& name) const;
    void deleteUser(const QString& name) const;

private:
    const QString sqlRequest(const QString& request) const;

private:
    QString version;
    QString name;
    unsigned int port;
    QString status;
    QString owner;
    QString dataDirectory;
    QString logFile;
};

#endif // PGSQLCLUSTER_H
