#ifndef PLUGINCONTAINER_H
#define PLUGINCONTAINER_H

#include "gmc-common_global.h"

#include "nodecontainer.h"

class QWidget;
#ifndef MAKSIM_MC
class QAbstractItemModel;
class QPluginLoader;
class QDialog;
#endif
class QPoint;



class TaskDescription;
class TreeNode;
class Plugin;
class Element;


class GMC_COMMON_SHARED_EXPORT PluginContainer : public NodeContainer
{

    Q_OBJECT

    friend class PluginModel;

signals:

    void contentElementWidgetChanged( int );
    void customContextMenuRequested( const QPoint & );

public:

    PluginContainer( QObject * /*parent*/  = nullptr );
    virtual ~PluginContainer();

    qulonglong availableOperationsClass() const;
    const QString &pluginPath() const;
    const QList< TreeNode *> &modules() const;

    QAbstractItemModel *pluginModel() const;

    void loadPlugins( const QString & /*pluginPath*/ );
    void unloadPlugins();

public slots:

    void showPluginDialog() const;

protected:

    qulonglong _availableOperationsClass;

    QWidget *_parentWidget;
    QString _pluginPath;
    QList< QPair< QPluginLoader *, Plugin * >  > _pluginLoaders;
    QList< TreeNode* > _modules;
    QAbstractItemModel *_pluginModel;
    QDialog *_pluginDialog;

};

#endif // PLUGINCONTAINER_H
