#ifndef TASKOBSERVERDIALOG_H
#define TASKOBSERVERDIALOG_H

#include "gmc-common_global.h"

#include <QDialog>
#include <QModelIndex>

class QItemSelection;

class TaskObserver;

namespace Ui
{
    class TaskObserverDialog;
}

class GMC_COMMON_SHARED_EXPORT TaskObserverDialog : public QDialog
{
    Q_OBJECT

public:

    TaskObserverDialog( TaskObserver  * /*_taskObserver*/
                      , QWidget * /*parent*/ = nullptr );
    ~TaskObserverDialog();

    void blockCloseButton();
    void unblockCloseButton();

protected:

    void showEvent( QShowEvent * /*event*/ ) override;
    void closeEvent( QCloseEvent * /*event*/ ) override;
    void keyPressEvent( QKeyEvent * /*event*/ ) override;

    void loadSettings();
    void saveSettings() const;

protected slots:

    void gotoMessageWidget();
    void gotoTaskWidget();
    void enableMoreButtonSelectChange(const QModelIndex & /*index*/ = QModelIndex() );
    void enableMoreButtonSelectChange( const QItemSelection & /*itemSelection*/ );
    void enableMoreButtonDataChange( const QModelIndex & /*index*/ = QModelIndex() );
    void moreButtonClick( bool );
    void doubleClick( const QModelIndex & /*index*/ );
    void stopButtonClick();

private:

    Ui::TaskObserverDialog *_ui;
    TaskObserver *_taskObserver;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT BlockDialog : public QDialog
{
    Q_OBJECT

public:

    BlockDialog( QWidget * /*parent*/ = nullptr );
    virtual ~BlockDialog();

};

//******************************************************************************

#endif // TASKOBSERVERDIALOG_H
